<html>
<head>
<title>OGRE: OgrePatchSurface.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li><a href="classes.html"><span>Classes</span></a></li>
    <li class="current"><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="dir_d6c9b501d36b850bf0bac687671293db.html">OgreMain</a>&nbsp;&raquo&nbsp;<a class="el" href="dir_f35e1e76cd4423745a1cccb1f171d4e3.html">include</a></div>
<h1>OgrePatchSurface.h</h1><a href="OgrePatchSurface_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2006 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment">Also see acknowledgements in Readme.html</span>
<a name="l00009"></a>00009 <span class="comment"></span>
<a name="l00010"></a>00010 <span class="comment">This program is free software; you can redistribute it and/or modify it under</span>
<a name="l00011"></a>00011 <span class="comment">the terms of the GNU Lesser General Public License as published by the Free Software</span>
<a name="l00012"></a>00012 <span class="comment">Foundation; either version 2 of the License, or (at your option) any later</span>
<a name="l00013"></a>00013 <span class="comment">version.</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">This program is distributed in the hope that it will be useful, but WITHOUT</span>
<a name="l00016"></a>00016 <span class="comment">ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS</span>
<a name="l00017"></a>00017 <span class="comment">FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">You should have received a copy of the GNU Lesser General Public License along with</span>
<a name="l00020"></a>00020 <span class="comment">this program; if not, write to the Free Software Foundation, Inc., 59 Temple</span>
<a name="l00021"></a>00021 <span class="comment">Place - Suite 330, Boston, MA 02111-1307, USA, or go to</span>
<a name="l00022"></a>00022 <span class="comment">http://www.gnu.org/copyleft/lesser.txt.</span>
<a name="l00023"></a>00023 <span class="comment"></span>
<a name="l00024"></a>00024 <span class="comment">You may alternatively use this source under the terms of a specific version of</span>
<a name="l00025"></a>00025 <span class="comment">the OGRE Unrestricted License provided you have obtained such a license from</span>
<a name="l00026"></a>00026 <span class="comment">Torus Knot Software Ltd.</span>
<a name="l00027"></a>00027 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00028"></a>00028 <span class="comment">*/</span>
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __PatchSurface_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __PatchSurface_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include "<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>"</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="preprocessor">#include "<a class="code" href="OgreVector3_8h.html">OgreVector3.h</a>"</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include "<a class="code" href="OgreString_8h.html">OgreString.h</a>"</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include "<a class="code" href="OgreRenderOperation_8h.html">OgreRenderOperation.h</a>"</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include "<a class="code" href="OgreAxisAlignedBox_8h.html">OgreAxisAlignedBox.h</a>"</span>
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 <span class="keyword">namespace </span>Ogre {
<a name="l00040"></a>00040 
<a name="l00047"></a><a class="code" href="classOgre_1_1PatchSurface.html">00047</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1PatchSurface.html" title="A surface which is defined by curves of some kind to form a patch, e.g.">PatchSurface</a>
<a name="l00048"></a>00048     {
<a name="l00049"></a>00049     <span class="keyword">public</span>:
<a name="l00050"></a>00050         <a class="code" href="classOgre_1_1PatchSurface.html" title="A surface which is defined by curves of some kind to form a patch, e.g.">PatchSurface</a>();
<a name="l00051"></a>00051         ~<a class="code" href="classOgre_1_1PatchSurface.html" title="A surface which is defined by curves of some kind to form a patch, e.g.">PatchSurface</a>();
<a name="l00052"></a>00052 
<a name="l00053"></a><a class="code" href="classOgre_1_1PatchSurface.html#bedf8abe8fa9fb9b1b7cff118cd2e278">00053</a>         <span class="keyword">enum</span> <a class="code" href="classOgre_1_1PatchSurface.html#bedf8abe8fa9fb9b1b7cff118cd2e278">PatchSurfaceType</a>
<a name="l00054"></a>00054         {
<a name="l00056"></a><a class="code" href="classOgre_1_1PatchSurface.html#bedf8abe8fa9fb9b1b7cff118cd2e2783018de74c08da01f0eeea0f1445f1c8e">00056</a>             PST_BEZIER
<a name="l00057"></a>00057         };
<a name="l00058"></a>00058 
<a name="l00060"></a>00060         <span class="keyword">enum</span>
<a name="l00061"></a>00061         {
<a name="l00062"></a><a class="code" href="classOgre_1_1PatchSurface.html#7ee650d77c69b42c43fb7553118c2503575b3489dac0ce9bffbad3d630b76830">00062</a>             AUTO_LEVEL = -1
<a name="l00063"></a>00063         };
<a name="l00064"></a>00064 
<a name="l00065"></a><a class="code" href="classOgre_1_1PatchSurface.html#3786509c9aac2a5ea44848e3f49c5eee">00065</a>         <span class="keyword">enum</span> <a class="code" href="classOgre_1_1PatchSurface.html#3786509c9aac2a5ea44848e3f49c5eee">VisibleSide</a> {
<a name="l00067"></a><a class="code" href="classOgre_1_1PatchSurface.html#3786509c9aac2a5ea44848e3f49c5eeebe7d46958e7b6cf27e83c3e5600dafb2">00067</a>             VS_FRONT,
<a name="l00069"></a><a class="code" href="classOgre_1_1PatchSurface.html#3786509c9aac2a5ea44848e3f49c5eee644ea2565457231655d0dea56da799ec">00069</a>             VS_BACK,
<a name="l00071"></a><a class="code" href="classOgre_1_1PatchSurface.html#3786509c9aac2a5ea44848e3f49c5eeea4aa50d12e90df02c8d549e85d365eaa">00071</a>             VS_BOTH
<a name="l00072"></a>00072         };
<a name="l00100"></a>00100         <span class="keywordtype">void</span> defineSurface(<span class="keywordtype">void</span>* controlPointBuffer, 
<a name="l00101"></a>00101             <a class="code" href="classOgre_1_1VertexDeclaration.html" title="This class declares the format of a set of vertex inputs, which can be issued to...">VertexDeclaration</a> *declaration, <span class="keywordtype">size_t</span> width, <span class="keywordtype">size_t</span> height,
<a name="l00102"></a>00102             PatchSurfaceType pType = PST_BEZIER, 
<a name="l00103"></a>00103             <span class="keywordtype">size_t</span> uMaxSubdivisionLevel = AUTO_LEVEL, <span class="keywordtype">size_t</span> vMaxSubdivisionLevel = AUTO_LEVEL,
<a name="l00104"></a>00104             VisibleSide visibleSide = VS_FRONT);
<a name="l00105"></a>00105 
<a name="l00111"></a>00111         <span class="keywordtype">size_t</span> getRequiredVertexCount(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00117"></a>00117         <span class="keywordtype">size_t</span> getRequiredIndexCount(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00118"></a>00118 
<a name="l00120"></a>00120         <span class="keywordtype">size_t</span> getCurrentIndexCount(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00122"></a><a class="code" href="classOgre_1_1PatchSurface.html#b83c4281f95bb02b8cbb4b41f97b9e2e">00122</a>         <span class="keywordtype">size_t</span> getIndexOffset(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mIndexOffset; }
<a name="l00124"></a><a class="code" href="classOgre_1_1PatchSurface.html#c545ac395017801a17d0e421d0e50101">00124</a>         <span class="keywordtype">size_t</span> getVertexOffset(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mVertexOffset; }
<a name="l00125"></a>00125 
<a name="l00126"></a>00126 
<a name="l00128"></a>00128         <span class="keyword">const</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>&amp; getBounds(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00131"></a>00131         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getBoundingSphereRadius(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00147"></a>00147         <span class="keywordtype">void</span> build(<a class="code" href="classOgre_1_1HardwareVertexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareVertexBufferSharedPtr</a> destVertexBuffer, <span class="keywordtype">size_t</span> vertexStart,
<a name="l00148"></a>00148             <a class="code" href="classOgre_1_1HardwareIndexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareIndexBufferSharedPtr</a> destIndexBuffer, <span class="keywordtype">size_t</span> indexStart);
<a name="l00149"></a>00149 
<a name="l00158"></a>00158         <span class="keywordtype">void</span> setSubdivisionFactor(<a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> factor);
<a name="l00159"></a>00159 
<a name="l00161"></a>00161         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getSubdivisionFactor(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00162"></a>00162 
<a name="l00163"></a><a class="code" href="classOgre_1_1PatchSurface.html#d3a4316d8594bbc7173a26703bdab2b1">00163</a>         <span class="keywordtype">void</span>* getControlPointBuffer(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00164"></a>00164 <span class="keyword">        </span>{
<a name="l00165"></a>00165             <span class="keywordflow">return</span> mControlPointBuffer;
<a name="l00166"></a>00166         }
<a name="l00169"></a><a class="code" href="classOgre_1_1PatchSurface.html#41fb9a71633f5658bac6c83403f46a43">00169</a>         <span class="keywordtype">void</span> notifyControlPointBufferDeallocated(<span class="keywordtype">void</span>) { 
<a name="l00170"></a>00170             mControlPointBuffer = 0;
<a name="l00171"></a>00171         }
<a name="l00172"></a>00172     <span class="keyword">protected</span>:
<a name="l00174"></a><a class="code" href="classOgre_1_1PatchSurface.html#437c71a16caed7a552d5de325323f7a3">00174</a>         <a class="code" href="classOgre_1_1VertexDeclaration.html" title="This class declares the format of a set of vertex inputs, which can be issued to...">VertexDeclaration</a>* mDeclaration;
<a name="l00176"></a><a class="code" href="classOgre_1_1PatchSurface.html#bc9fc2a6c93d26afce8e12f20a5ae36a">00176</a>         <span class="keywordtype">void</span>* mControlPointBuffer;
<a name="l00178"></a><a class="code" href="classOgre_1_1PatchSurface.html#8eb452f175ed459c32224a24c4111091">00178</a>         <a class="code" href="classOgre_1_1PatchSurface.html#bedf8abe8fa9fb9b1b7cff118cd2e278">PatchSurfaceType</a> mType;
<a name="l00180"></a><a class="code" href="classOgre_1_1PatchSurface.html#223697279c497602e1338134782c9691">00180</a>         <span class="keywordtype">size_t</span> mCtlWidth;
<a name="l00182"></a><a class="code" href="classOgre_1_1PatchSurface.html#c6ccdf6c36e9e75bdd71455292bfb210">00182</a>         <span class="keywordtype">size_t</span> mCtlHeight;
<a name="l00184"></a><a class="code" href="classOgre_1_1PatchSurface.html#495d1ea0cc206d5be6fd2b1376534903">00184</a>         <span class="keywordtype">size_t</span> mCtlCount;
<a name="l00186"></a><a class="code" href="classOgre_1_1PatchSurface.html#0292f4963f60a974876a8185de206d7f">00186</a>         <span class="keywordtype">size_t</span> mULevel;
<a name="l00188"></a><a class="code" href="classOgre_1_1PatchSurface.html#de1780fa07ac3eb2cd77a1e4e7effd48">00188</a>         <span class="keywordtype">size_t</span> mVLevel;
<a name="l00190"></a><a class="code" href="classOgre_1_1PatchSurface.html#7263e6acf1fc55ecd2bb772c471a2924">00190</a>         <span class="keywordtype">size_t</span> mMaxULevel;
<a name="l00191"></a><a class="code" href="classOgre_1_1PatchSurface.html#d253e0f7299f615d5f6603eb788a27db">00191</a>         <span class="keywordtype">size_t</span> mMaxVLevel;
<a name="l00193"></a><a class="code" href="classOgre_1_1PatchSurface.html#4077a4271389af7bc4ec9e807bf91cde">00193</a>         <span class="keywordtype">size_t</span> mMeshWidth;
<a name="l00195"></a><a class="code" href="classOgre_1_1PatchSurface.html#5b31d465366d1856ab5f7a811cd3907f">00195</a>         <span class="keywordtype">size_t</span> mMeshHeight;
<a name="l00197"></a><a class="code" href="classOgre_1_1PatchSurface.html#eb543caba5713a3468d87c147873a35c">00197</a>         <a class="code" href="classOgre_1_1PatchSurface.html#3786509c9aac2a5ea44848e3f49c5eee">VisibleSide</a> mVSide;
<a name="l00198"></a>00198 
<a name="l00199"></a><a class="code" href="classOgre_1_1PatchSurface.html#d7bed3b4c073e58963c4f518824dc213">00199</a>         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> mSubdivisionFactor;
<a name="l00200"></a>00200 
<a name="l00201"></a><a class="code" href="classOgre_1_1PatchSurface.html#d9a91befebe2cbc4a4b845d8f28b9b89">00201</a>         std::vector&lt;Vector3&gt; mVecCtlPoints;
<a name="l00202"></a>00202 
<a name="l00205"></a>00205         <span class="keywordtype">size_t</span> findLevel( <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; a, <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; b, <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; c);
<a name="l00206"></a>00206 
<a name="l00207"></a>00207         <span class="keywordtype">void</span> distributeControlPoints(<span class="keywordtype">void</span>* lockedBuffer);
<a name="l00208"></a>00208         <span class="keywordtype">void</span> subdivideCurve(<span class="keywordtype">void</span>* lockedBuffer, <span class="keywordtype">size_t</span> startIdx, <span class="keywordtype">size_t</span> stepSize, <span class="keywordtype">size_t</span> numSteps, <span class="keywordtype">size_t</span> iterations);
<a name="l00209"></a>00209         <span class="keywordtype">void</span> interpolateVertexData(<span class="keywordtype">void</span>* lockedBuffer, <span class="keywordtype">size_t</span> leftIndex, <span class="keywordtype">size_t</span> rightIndex, <span class="keywordtype">size_t</span> destIndex);
<a name="l00210"></a>00210         <span class="keywordtype">void</span> makeTriangles(<span class="keywordtype">void</span>);
<a name="l00211"></a>00211 
<a name="l00212"></a>00212         <span class="keywordtype">size_t</span> getAutoULevel(<span class="keywordtype">bool</span> forMax = <span class="keyword">false</span>);
<a name="l00213"></a>00213         <span class="keywordtype">size_t</span> getAutoVLevel(<span class="keywordtype">bool</span> forMax = <span class="keyword">false</span>);
<a name="l00214"></a>00214 
<a name="l00215"></a><a class="code" href="classOgre_1_1PatchSurface.html#b71020e960b8f454f02ac7008ff8f149">00215</a>         <a class="code" href="classOgre_1_1HardwareVertexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareVertexBufferSharedPtr</a> mVertexBuffer;
<a name="l00216"></a><a class="code" href="classOgre_1_1PatchSurface.html#dd834eb17f4476747c73d30c42c40ad8">00216</a>         <a class="code" href="classOgre_1_1HardwareIndexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareIndexBufferSharedPtr</a> mIndexBuffer;
<a name="l00217"></a><a class="code" href="classOgre_1_1PatchSurface.html#947c6821f4d14e3983e5f8e702ee1ba1">00217</a>         <span class="keywordtype">size_t</span> mVertexOffset;
<a name="l00218"></a><a class="code" href="classOgre_1_1PatchSurface.html#b20d64e316e68c29df2e0feacd8ce82c">00218</a>         <span class="keywordtype">size_t</span> mIndexOffset;
<a name="l00219"></a><a class="code" href="classOgre_1_1PatchSurface.html#540444f2d390279342b950e34651e5c8">00219</a>         <span class="keywordtype">size_t</span> mRequiredVertexCount;
<a name="l00220"></a><a class="code" href="classOgre_1_1PatchSurface.html#8f7f0bb8ee32d786e94a2d58c5d1cc47">00220</a>         <span class="keywordtype">size_t</span> mRequiredIndexCount;
<a name="l00221"></a><a class="code" href="classOgre_1_1PatchSurface.html#fa053936dd43a2856e64cd4c39e21d73">00221</a>         <span class="keywordtype">size_t</span> mCurrIndexCount;
<a name="l00222"></a>00222 
<a name="l00223"></a><a class="code" href="classOgre_1_1PatchSurface.html#2da824a653e19ad4b6196725e462c192">00223</a>         <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a> mAABB;
<a name="l00224"></a><a class="code" href="classOgre_1_1PatchSurface.html#f487823bcd4b0fc386b426599c7b19cf">00224</a>         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> mBoundingSphere;
<a name="l00225"></a>00225 
<a name="l00226"></a>00226 
<a name="l00227"></a>00227 
<a name="l00228"></a>00228     };
<a name="l00229"></a>00229 
<a name="l00230"></a>00230 
<a name="l00231"></a>00231 } <span class="comment">// namespace</span>
<a name="l00232"></a>00232 
<a name="l00233"></a>00233 <span class="preprocessor">#endif</span>
</pre></div><hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:48:54 2008
</p>
</body>
</html>
